/* ***** BEGIN LICENSE BLOCK *****
 *   Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XUL Reference.
 *
 * The Initial Developer of the Original Code is
 *
 * Einar Egilsson. (email: xulreference@einaregilsson.com)
 *
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


var XRObjects = {

    //Known objects
    ifaces     : {},
    comps      : {},
    xul        : {},
    xbl        : {},
    obj        : {},
    events     : {},
    xulElementCommon : {},
    
    types : ['comps', 'ifaces','xul', 'xbl', 'obj', 'events', 'xulElementCommon'],
    
    loadObjectsFromFile: function() {
        
        var file, data;
        for each (var name in this.types) {
            file = XRLib.getExtensionChromePathFile();
            file.append('reference');
            file.append(name + '.txt');
            data = XRLib.getFileContents(file.path);
            XRLib.debug('%1:\n%2'._(name, data));
            this[name] = eval(data);
        }
    },


    saveObjectsToFile : function() {
        var name, file;
        for each (var name in this.types) {
            file = XRLib.getExtensionChromePathFile();
            file.append('reference');
            file.append(name + '.txt');
            XRLib.saveToFile(file.path, this[name].toSource().replace(/, /gi, "\n, "));
        }
 
        //Notify other instances
        var service = Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService);  
        service.notifyObservers(null, 'XULReference:reload', null); 
    },
    
    observe : function(aSubject, aTopic, aData) {
        if (aTopic == 'XULReference:reload') {
            this.loadObjectsFromFile();
        }
        XRLib.debug('Reloaded after receiving notification');
    },
    
    onLoad : function() {
        Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService).addObserver(XRObjects, 'XULReference:reload', false);
    },
    
    onUnload : function() {
        Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService).removeObserver(XRObjects, 'XULReference:reload');
    }
    
    
};

window.addEventListener('load', XRObjects.onLoad, false);
window.addEventListener('unload', XRObjects.onUnload, false);
